import socket;

// dmd sockettest socket ws2_32.lib


int main()
{
	/+
		//regular blocking
	Socket s = new Socket(AddressFamily.INET, SocketType.STREAM, ProtocolType.IP);
	s.connect(new InternetAddress("127.0.0.1", 444));
	s.send("Foo!");
	printf("Local=%.*s, Remote=%.*s\r\n", s.localAddress().toString(), s.remoteAddress().toString());
	s.close();
	+/
	
	
	/+
		//nonblocking with select()
	Socket s = new Socket(AddressFamily.INET, SocketType.STREAM, ProtocolType.IP);
	s.blocking = false;
	assert(s.blocking == false);
	SocketSet sset = new SocketSet(1);
	sset.add(s);
	s.connect(new InternetAddress("127.0.0.1", 444));
	printf("select=%d\r\n", Socket.select(null, sset, null, 1000)); //wait for connection
	s.send(cast(dchar[])"Foo!");
	sset.reset(1);
	sset.add(s);
	printf("select=%d\r\n", Socket.select(null, sset, null, 1000)); //wait for send
	printf("Local=%.*s, Remote=%.*s\r\n", s.localAddress().toString(), s.remoteAddress().toString());
	s.close();
	+/
	
	
	/+
		//nonblocking listen() with select()
	Socket s = new Socket(AddressFamily.INET, SocketType.STREAM, ProtocolType.IP);
	s.blocking = false;
	SocketSet sset = new SocketSet(1);
	sset.add(s);
	s.bind(new InternetAddress(444));
	s.listen(10);
	printf("select=%d\r\n", Socket.select(sset, null, null)); //wait for accept
	with(s.accept())
	{
		printf("Accepted connection from %.*s\r\n", remoteAddress().toString());
		close();
	}
	s.close();
	+/
	
	
		//nonblocking connect() to 127.0.0.1 port 80 with select() and display web page
	Socket s = new Socket(AddressFamily.INET, SocketType.STREAM, ProtocolType.IP);
	s.blocking = false;

	SocketSet sset = new SocketSet(1);
	sset.add(s);

	s.connect(new InternetAddress("127.0.0.1", 80));
	if(!Socket.select(null, sset, null, 3000000)) //3secs
		throw new Exception("Connection timed out.");
	s.send("GET / HTTP/1.1\r\nHost: localhost\r\n\r\n");
	
	char[1024] buf;
	int read;
	for(;;)
	{
		sset.reset(1);
		sset.add(s);
		
		if(Socket.select(sset, null, null, 1000000))
		{
			read = s.receive(buf);
			if(read)
			{
				printf("%.*s", buf[0 .. read]);
			}
			else
			{
				printf("\r\n\r\nConnection closed.");
				break;
			}
		}
		else
		{
			printf("\r\n\r\nRead timeout.");
			break;
		}
	}
	s.close();
	
	return 0;
}

